# Searches CppUnit.
#
# Handles REQUIRED argument properly.
#
# The following variables will be set, if found:
# - CPPUNIT_FOUND
# - CPPUNIT_INCLUDE_DIR
# - CPPUNIT_LIBRARIES



FIND_PATH(CPPUNIT_INCLUDE_DIR  cppunit/TestCase.h ${CMAKE_SYSTEM_INCLUDE_PATH})
FIND_LIBRARY(CPPUNIT_LIBRARIES cppunit            ${CMAKE_SYSTEM_LIBRARY_PATH})

IF(CPPUNIT_INCLUDE_DIR AND CPPUNIT_LIBRARIES)
	SET(CPPUNIT_FOUND true)
ENDIF(CPPUNIT_INCLUDE_DIR AND CPPUNIT_LIBRARIES)

IF(NOT CPPUNIT_FOUND)
	IF(CPPUNIT_FIND_REQUIRED)
		MESSAGE(FATAL_ERROR "Required library CppUnit not found.")
	ELSE(CPPUNIT_FIND_REQUIRED)
		MESSAGE(STATUS "CppUnit not found, testing not possible.")
	ENDIF(CPPUNIT_FIND_REQUIRED)
ELSE(NOT CPPUNIT_FOUND)
	MESSAGE(STATUS "Found CppUnit: ${CPPUNIT_INCLUDE_DIR}, ${CPPUNIT_LIBRARIES}.")
ENDIF(NOT CPPUNIT_FOUND)
